<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/ButtonsCommanderSwitch.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('ButtonsCommanderSwitch_8hpp_source.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">ButtonsCommanderSwitch.hpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#ifndef __buttonsCommanderSwitch_H__</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#define __buttonsCommanderSwitch_H__</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="Commanders_8h.html">Commanders.h</a>&gt;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#ifndef NO_BUTTONSCOMMANDER</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef NO_BUTTONSCOMMANDERSWITCH</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;Chain.hpp&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno"><a class="line" href="structEventPin.html">   14</a></span>&#160;<span class="keyword">struct </span><a class="code" href="structEventPin.html">EventPin</a></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;{</div><div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="structEventPin.html#a55bd77f9470bf8903042423278f950c2">   16</a></span>&#160;    GPIO_pin_t <a class="code" href="structEventPin.html#a55bd77f9470bf8903042423278f950c2">Pin</a>; </div><div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="structEventPin.html#ad356be83493e83623b5f8756f9f99808">   17</a></span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="structEventPin.html#ad356be83493e83623b5f8756f9f99808">Id</a>; </div><div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="structEventPin.html#a8b4c6321f1b8abe7db2a5308f077533b">   18</a></span>&#160;    <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a> <a class="code" href="structEventPin.html#a8b4c6321f1b8abe7db2a5308f077533b">Event</a>; </div><div class="line"><a name="l00019"></a><span class="lineno"><a class="line" href="structEventPin.html#a76a1ef2eda3115e051f49861093cd6ff">   19</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="structEventPin.html#a76a1ef2eda3115e051f49861093cd6ff">Data</a>; </div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;};</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="classButtonsCommanderSwitch.html">   33</a></span>&#160;<span class="keyword">class </span><a class="code" href="classButtonsCommanderSwitch.html">ButtonsCommanderSwitch</a> : <span class="keyword">public</span> <a class="code" href="classButtonsCommanderButton.html">ButtonsCommanderButton</a></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;{</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; <span class="keyword">private</span>:</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> debounceDelay;    <span class="comment">// the debounce time; increase if the output flickers</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <a class="code" href="classCMDRSCHAINEDLIST.html">CMDRSCHAINEDLIST&lt;EventPin&gt;</a> EventPins;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    GPIO_pin_t lastSelectedPin;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordtype">int</span> lastButtonState;   <span class="comment">// the previous reading from the current input pin</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> lastDebounceTime;  <span class="comment">// the last time the current output pin was toggled</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <a class="code" href="classButtonsCommanderSwitch.html#ac0868173b88f84ea44ecdee9e0dfd82f">ButtonsCommanderSwitch</a>();</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    </div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classButtonsCommanderSwitch.html#adf7871a996c39e3dcbc30d1ad98de2ba">begin</a>();</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <a class="code" href="structEventPin.html">EventPin</a> *<a class="code" href="classButtonsCommanderSwitch.html#a5b1a16f717941df169781ab96a5d1650">AddEvent</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <span class="keywordtype">int</span> inPin, <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a> inEvent = <a class="code" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490ca4c6e59b277bf1f4430a136faab150a61">COMMANDERS_EVENT_MOVEPOSITIONID</a>, <span class="keywordtype">int</span> inData = 0);</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classButtonsCommanderSwitch.html#ac5acada95c180aa8011e8b4c4ba3e6ce">beforeFirstLoop</a>();</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classButtonsCommanderSwitch.html#a3e66f87ce692b0524bf9940dec663d21">loop</a>();</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classButtonsCommanderButton.html#acbdd1d63fed7736c7358105428fbfd9c">GetId</a>(GPIO_pin_t inPin) <span class="keyword">const</span>;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classButtonsCommanderSwitch.html#ab4ff8f2eead168e08c2f385022c06a4a">loopOnePin</a>(GPIO_pin_t inPin, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inId, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> inPreviousId,</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> *apDebounceDelay, GPIO_pin_t *apLastSelectedPin,</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keywordtype">int</span> *apLastButtonState, <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> *apLastDebounceTime, <span class="keywordtype">bool</span> inSendEvent = <span class="keyword">true</span>);</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_PRINT_COMMANDERS</span></div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keywordtype">void</span> printCommander();</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;};</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="preprocessor">#endif</span></div><div class="ttc" id="classButtonsCommanderSwitch_html_ab4ff8f2eead168e08c2f385022c06a4a"><div class="ttname"><a href="classButtonsCommanderSwitch.html#ab4ff8f2eead168e08c2f385022c06a4a">ButtonsCommanderSwitch::loopOnePin</a></div><div class="ttdeci">static unsigned long loopOnePin(GPIO_pin_t inPin, unsigned long inId, unsigned long inPreviousId, unsigned long *apDebounceDelay, GPIO_pin_t *apLastSelectedPin, int *apLastButtonState, unsigned long *apLastDebounceTime, bool inSendEvent = true)</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8cpp_source.html#l00072">ButtonsCommanderSwitch.cpp:72</a></div></div>
<div class="ttc" id="classButtonsCommanderButton_html_acbdd1d63fed7736c7358105428fbfd9c"><div class="ttname"><a href="classButtonsCommanderButton.html#acbdd1d63fed7736c7358105428fbfd9c">ButtonsCommanderButton::GetId</a></div><div class="ttdeci">unsigned long GetId() const </div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderButton_8hpp_source.html#l00030">ButtonsCommanderButton.hpp:30</a></div></div>
<div class="ttc" id="classButtonsCommanderSwitch_html_a3e66f87ce692b0524bf9940dec663d21"><div class="ttname"><a href="classButtonsCommanderSwitch.html#a3e66f87ce692b0524bf9940dec663d21">ButtonsCommanderSwitch::loop</a></div><div class="ttdeci">unsigned long loop()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8cpp_source.html#l00149">ButtonsCommanderSwitch.cpp:149</a></div></div>
<div class="ttc" id="Events_8h_html_a36239a7eea6194f04e73e80d7419490ca4c6e59b277bf1f4430a136faab150a61"><div class="ttname"><a href="Events_8h.html#a36239a7eea6194f04e73e80d7419490ca4c6e59b277bf1f4430a136faab150a61">COMMANDERS_EVENT_MOVEPOSITIONID</a></div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00032">Events.h:32</a></div></div>
<div class="ttc" id="classButtonsCommanderSwitch_html_a5b1a16f717941df169781ab96a5d1650"><div class="ttname"><a href="classButtonsCommanderSwitch.html#a5b1a16f717941df169781ab96a5d1650">ButtonsCommanderSwitch::AddEvent</a></div><div class="ttdeci">EventPin * AddEvent(unsigned long inId, int inPin, COMMANDERS_EVENT_TYPE inEvent = COMMANDERS_EVENT_MOVEPOSITIONID, int inData = 0)</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8cpp_source.html#l00060">ButtonsCommanderSwitch.cpp:60</a></div></div>
<div class="ttc" id="classButtonsCommanderSwitch_html_adf7871a996c39e3dcbc30d1ad98de2ba"><div class="ttname"><a href="classButtonsCommanderSwitch.html#adf7871a996c39e3dcbc30d1ad98de2ba">ButtonsCommanderSwitch::begin</a></div><div class="ttdeci">void begin()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8cpp_source.html#l00025">ButtonsCommanderSwitch.cpp:25</a></div></div>
<div class="ttc" id="classCMDRSCHAINEDLIST_html"><div class="ttname"><a href="classCMDRSCHAINEDLIST.html">CMDRSCHAINEDLIST&lt; EventPin &gt;</a></div></div>
<div class="ttc" id="classButtonsCommanderButton_html"><div class="ttname"><a href="classButtonsCommanderButton.html">ButtonsCommanderButton</a></div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderButton_8hpp_source.html#l00015">ButtonsCommanderButton.hpp:15</a></div></div>
<div class="ttc" id="classButtonsCommanderSwitch_html"><div class="ttname"><a href="classButtonsCommanderSwitch.html">ButtonsCommanderSwitch</a></div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8hpp_source.html#l00033">ButtonsCommanderSwitch.hpp:33</a></div></div>
<div class="ttc" id="structEventPin_html_a76a1ef2eda3115e051f49861093cd6ff"><div class="ttname"><a href="structEventPin.html#a76a1ef2eda3115e051f49861093cd6ff">EventPin::Data</a></div><div class="ttdeci">int Data</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8hpp_source.html#l00019">ButtonsCommanderSwitch.hpp:19</a></div></div>
<div class="ttc" id="classButtonsCommanderSwitch_html_ac0868173b88f84ea44ecdee9e0dfd82f"><div class="ttname"><a href="classButtonsCommanderSwitch.html#ac0868173b88f84ea44ecdee9e0dfd82f">ButtonsCommanderSwitch::ButtonsCommanderSwitch</a></div><div class="ttdeci">ButtonsCommanderSwitch()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8cpp_source.html#l00011">ButtonsCommanderSwitch.cpp:11</a></div></div>
<div class="ttc" id="structEventPin_html_a8b4c6321f1b8abe7db2a5308f077533b"><div class="ttname"><a href="structEventPin.html#a8b4c6321f1b8abe7db2a5308f077533b">EventPin::Event</a></div><div class="ttdeci">COMMANDERS_EVENT_TYPE Event</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8hpp_source.html#l00018">ButtonsCommanderSwitch.hpp:18</a></div></div>
<div class="ttc" id="classButtonsCommanderSwitch_html_ac5acada95c180aa8011e8b4c4ba3e6ce"><div class="ttname"><a href="classButtonsCommanderSwitch.html#ac5acada95c180aa8011e8b4c4ba3e6ce">ButtonsCommanderSwitch::beforeFirstLoop</a></div><div class="ttdeci">void beforeFirstLoop()</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8cpp_source.html#l00126">ButtonsCommanderSwitch.cpp:126</a></div></div>
<div class="ttc" id="Events_8h_html_a36239a7eea6194f04e73e80d7419490c"><div class="ttname"><a href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a></div><div class="ttdeci">COMMANDERS_EVENT_TYPE</div><div class="ttdef"><b>Definition:</b> <a href="Events_8h_source.html#l00025">Events.h:25</a></div></div>
<div class="ttc" id="structEventPin_html_ad356be83493e83623b5f8756f9f99808"><div class="ttname"><a href="structEventPin.html#ad356be83493e83623b5f8756f9f99808">EventPin::Id</a></div><div class="ttdeci">unsigned long Id</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8hpp_source.html#l00017">ButtonsCommanderSwitch.hpp:17</a></div></div>
<div class="ttc" id="structEventPin_html_a55bd77f9470bf8903042423278f950c2"><div class="ttname"><a href="structEventPin.html#a55bd77f9470bf8903042423278f950c2">EventPin::Pin</a></div><div class="ttdeci">GPIO_pin_t Pin</div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8hpp_source.html#l00016">ButtonsCommanderSwitch.hpp:16</a></div></div>
<div class="ttc" id="structEventPin_html"><div class="ttname"><a href="structEventPin.html">EventPin</a></div><div class="ttdef"><b>Definition:</b> <a href="ButtonsCommanderSwitch_8hpp_source.html#l00014">ButtonsCommanderSwitch.hpp:14</a></div></div>
<div class="ttc" id="Commanders_8h_html"><div class="ttname"><a href="Commanders_8h.html">Commanders.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>ButtonsCommanderSwitch.hpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
